Index: GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2599)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2622)
@@ -28,10 +28,12 @@
 #VIEWCELLS=../data/test1/test-viewcells.xml
 
-#SCENE=../data/Arena/arena-high-lods.obj
-#VIEWCELLS=../data/Arena/viewcells-5000.xml.gz
+SCENE=../data/Arena/arena-high-lods.obj
+VIEWCELLS=../data/Arena/viewcells-5000.xml.gz
 
 
-SCENE=../data/vienna/vienna_cropped.obj
-VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+#SCENE=../data/vienna/vienna_cropped.obj
+#VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+
+
 #VIEWCELLS=../data/vienna/vienna-sequential-30000-single-viewcell.xml
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2621)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2622)
@@ -91,5 +91,5 @@
   GlRendererBuffer(sceneGraph, viewcells, tree)
 {
-  mUseVbos = true;
+  mUseVbos = false;
   MakeCurrent();
   InitGL();
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2620)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2622)
@@ -89,5 +89,5 @@
 	mSceneGraph->CollectObjects(mObjects);
 
-#if 0
+#if 1
 	viewCellsManager->GetViewPoint(mViewPoint);
 	mViewDirection = Vector3(0,0,1);
@@ -105,5 +105,5 @@
 		                                      mDetectEmptyViewSpace);
 
-	mSnapErrorFrames = true;
+	mSnapErrorFrames = false;
 	mSnapPrefix = "snap/";
 	mUseForcedColors = false;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2620)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2622)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: po 21. I 14:57:24 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: po 21. I 21:36:51 2008
 # Project:  preprocessor.pro
 # Template: app
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel	(revision 2620)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel	(revision 2622)
@@ -4,5 +4,5 @@
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
 #COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_pass=500000 -samples_per_evaluation=10000000 -total_samples=500000000 -preprocessor_pvs_rendererror_samples=10000 -preprocessor_evaluatePixelError+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_pass=1000000 -samples_per_evaluation=10000000 -total_samples=250000000 -preprocessor_pvs_rendererror_samples=1000 -preprocessor_evaluatePixelError+ -preprocessor_detect_empty_viewspace+ -kd_pvs_area=1e-5 -view_cells_use_kd_pvs+ -af_use_kd_pvs+"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_pass=1000000 -samples_per_evaluation=10000000 -total_samples=250000000 -preprocessor_pvs_rendererror_samples=10000 -preprocessor_evaluatePixelError+ -preprocessor_detect_empty_viewspace+ -kd_pvs_area=1e-5 -view_cells_use_kd_pvs+ -af_use_kd_pvs+"
  
 #SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
@@ -35,5 +35,5 @@
 #VIEWCELLS=../data/vienna/vienna-seq-viewcells-20000.xml.gz
 
-PREFIX=../work/plots/osp-vienna-SG08c-PIXEL
+PREFIX=../work/plots/osp-vienna-SG08e-PIXEL
 
 #SCENE=../data/atlanta/atlanta2.x3d
@@ -41,21 +41,21 @@
 
 
-$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
--preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4l.xml \
--preprocessor_stats=$PREFIX-i-mixed-b1-n4l.log \
--preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4l.hlog
+# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+# -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4l.xml \
+# -preprocessor_stats=$PREFIX-i-mixed-b1-n4l.log \
+# -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4l.hlog
 
 
-# $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-# -preprocessor_visibility_file=$PREFIX-r-reference.xml \
-# -view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
-# -preprocessor_histogram_file=$PREFIX-r-reference.hlog
+$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-preprocessor_visibility_file=$PREFIX-r-reference.xml \
+-view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
+-preprocessor_histogram_file=$PREFIX-r-reference.hlog
 
-# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-#  -rss_distributions=direction -view_cells_filter_max_size=1 \
-#  -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
-#  -preprocessor_stats=$PREFIX-r-reference-global.log \
-#  -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+ -rss_distributions=direction -view_cells_filter_max_size=1 \
+ -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
+ -preprocessor_stats=$PREFIX-r-reference-global.log \
+ -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pompeii
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pompeii	(revision 2608)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pompeii	(revision 2622)
@@ -7,5 +7,5 @@
 #COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace- -total_samples=100000000 -samples_per_pass=1000000"
 
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace- -samples_per_evaluation=5000000 -samples_per_pass=1000000 -total_samples=1000000000 -view_cells_use_kd_pvs- -af_use_kd_pvs- -kd_pvs_area=1e-5"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace- -samples_per_evaluation=5000000 -samples_per_pass=1000000 -total_samples=1000000000 -view_cells_use_kd_pvs+ -af_use_kd_pvs- -kd_pvs_area=1e-5"
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_arena
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_arena	(revision 2617)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_arena	(revision 2622)
@@ -7,5 +7,5 @@
 
 #TIME TERMINATION
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=1000000000  -samples_per_pass=1000000 -total_samples=4000000000 -total_time=7200 -view_cells_use_kd_pvs+ -af_use_kd_pvs+ -kd_pvs_area=1e-5"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace- -total_samples=1000000000  -samples_per_pass=1000000 -total_samples=4000000000 -total_time=7200 -view_cells_use_kd_pvs+ -af_use_kd_pvs+ -kd_pvs_area=1e-5"
 
 
@@ -13,5 +13,5 @@
 VIEWCELLS=../data/Arena/viewcells-5000.xml.gz
 
-PREFIX=../work/plots/osp-arena-SG08a-TIME
+PREFIX=../work/plots/osp-arena-SG08x-TIME
 
 # $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \