Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel	(revision 2622)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel	(revision 2626)
@@ -41,4 +41,19 @@
 
 
+
+# $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -preprocessor_visibility_file=$PREFIX-r-reference.xml \
+# -view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
+# -preprocessor_histogram_file=$PREFIX-r-reference.hlog
+
+
+
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+#  -rss_distributions=direction -view_cells_filter_max_size=1 \
+#  -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
+#  -preprocessor_stats=$PREFIX-r-reference-global.log \
+#  -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+
+
 # $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
 # -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
@@ -47,15 +62,10 @@
 # -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4l.hlog
 
-
-$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--preprocessor_visibility_file=$PREFIX-r-reference.xml \
--view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
--preprocessor_histogram_file=$PREFIX-r-reference.hlog
-
-$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
- -rss_distributions=direction -view_cells_filter_max_size=1 \
- -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
- -preprocessor_stats=$PREFIX-r-reference-global.log \
- -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+-preprocessor_evaluate_filter+ \
+-preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4l.xml \
+-preprocessor_stats=$PREFIX-i-mixed-b1-n4l.log \
+-preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4f.hlog
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_vienna_pixel
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_vienna_pixel	(revision 2626)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_vienna_pixel	(revision 2626)
@@ -0,0 +1,56 @@
+#!/bin/sh
+
+
+#COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
+#COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace- -total_samples=500000000"
+
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -samples_per_evaluation=10000000 -samples_per_pass=1000000 -total_samples=250000000 -view_cells_use_kd_pvs+ -preprocessor_ray_cast_method=1 -preprocessor_pvs_rendererror_samples=10000 -preprocessor_evaluatePixelError+ -preprocessor_detect_empty_viewspace+ -kd_pvs_area=1e-5 -view_cells_use_kd_pvs+ -af_use_kd_pvs+"
+
+
+SCENE=../data/vienna/vienna_cropped.obj
+VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+#VIEWCELLS=../data/vienna/vienna-sequential-30000-single-viewcell.xml
+
+
+PREFIX=../work/plots/osp-vienna-SG08g-pixel
+
+
+######################
+######################
+
+$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-preprocessor_visibility_file=$PREFIX-reference.xml \
+-view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
+-preprocessor_histogram_file=$PREFIX-r-reference.hlog
+
+$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+ -rss_distributions=direction -view_cells_filter_max_size=1 \
+ -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
+ -preprocessor_stats=$PREFIX-reference-global.log \
+ -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+
+
+# USE THIS ONE!!!!!!
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.5 \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_radius_origin=1.0 \
+-mutation_radius_termination=0.2 \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m8-2.log 
+
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-preprocessor_evaluate_filter+ \
+-mutation_silhouette_prob=0.5 \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_radius_origin=1.0 \
+-mutation_radius_termination=0.2 \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m8-2f.log 